<?php
# ************** LICENCE ****************
/*
	Copyright (c) PORTANEO.

	This file is part of POSH (Portaneo Open Source Homepage) http://sourceforge.net/projects/posh/.

	POSH is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version

	POSH is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with Posh.  If not, see <http://www.gnu.org/licenses/>.
*/
# ***************************************
# POSH Configuration - Theme selection
#
# !! be careful, this file must be saved under uft8 format, and display an e accentuated here : é
# ***************************************

$folder="../portal/";
$not_access=1;
$isScript=false;
$isPortal=false;
$granted="A";
$pagename="admin/config_plugins.php";
$tabname="configstab";

require_once("includes.php");
set_include_path("../includes/");
require('header.inc.php');
require_once('../includes/file.inc.php');

$DB->getResults($plugin_getPluginList);
$inc=0;
$installed=array();
while ($row=$DB->fetch(0))
{
	$installed[$inc]=$row["name"];
	$inc++;
}
$DB->freeResults();

if (isset($_GET["error"])) echo "<font color='#ff0000'>".lg("errorPluginsInstall")."</font>";
?>


	<h1><img src="../images/ico_adm_plugins.gif" alt="" /> <?php echo lg("appPluginsConfiguration");?> :</h1>
	<p>
	<a href="config.php"><?php echo lg("backPrevPage");?></a>
	</p>
	<div class="box">
	<form action="scr_config_plugins.php" method="post">
	<h2><?php echo lg("plugins");?> :</h2>
	<table width='100%'>


<?php
	$dir='../includes/plugins/';
	
	$plugins = array();
	search_plugins($dir,$plugins,true);
	
	foreach ($plugins as $id => $p)
	{
		write_plugin_box($id,$p["name"],$p["description"],$p["dependencies"],$p["file"],$p["dir"],$p["link"],in_array($p["name"],$installed));
		launch_hook("display_plugin",$p);
	}
?>


	</table>
	<p class='submit'><input type="submit" value="<?php echo lg("saveModifications");?>" /></p>
	</form>
	</div>


<?php
write_admin_tabs($tabname);

require('footer.inc.php');


/*
 * Displays infos about a plugin
 * Input :
 *	$id (int) : plugin unique id (number of plugins red)
 *	$name (string) : plugin name
 *	$description (string)
 *	$dependencies (string) : others plugins that have to be installed before
 *	$file (string) : plugin file name (if the plugin is in the new format, else it's empty)
 *	$dir (string) : dir when the plugin file is found
 *	$link (string) : dir/file
 *	$installed (boolean) : true if the plugin is already installed
 */
function write_plugin_box($id,$name,$description,$dependencies,$file,$dir,$link,$installed)
{
	echo '<tr><td bgcolor="#efefef" width="30"><input type="checkbox" name="plug'.$id.'"';
	if ($installed){
		echo ' checked="checked" /><input type="hidden" name="plugi'.$id.'" value="1" />'."\n";
	} else echo ' /><input type="hidden" name="plugi'.$id.'" value="0" />'."\n";
	echo '<input type="hidden" name="name'.$id.'" value="'.$name.'" />'."\n";
	echo '<input type="hidden" name="desc'.$id.'" value="'.$description.'" />'."\n";
	echo '<input type="hidden" name="depend'.$id.'" value="'.$dependencies.'" />'."\n";
	if (!empty($file))
	echo '<input type="hidden" name="file'.$id.'" value="'.$dir.$file.'" />'."\n";
	echo '<input type="hidden" name="dir'.$id.'" value="'.'" />'."\n";
	echo '<input type="hidden" name="link'.$id.'" value="'.$link.'" /></td>'."\n";
	echo '<td bgcolor="#efefef"><b>'.$name.'</b></td></tr><tr><td></td><td>'.$description.'</td></tr>'."\n";
	if (strtolower($dependencies)!="no") echo '<tr><td></td><td style="color:#ff0000">'.lg("dependencies").' : <b>'.$dependencies.'</b></td></tr>'."\n";
}


/*
 * Search plugins in a dir
 * Do it recursively
 * Input :
 *	$path (string) : path to explore, looking for plugins
 *	$old_plugins (boolean) : look for old plugins (only at the root)
 * Output :
 *	$plugins (array) : plugins in the folder
 */
function search_plugins($path,&$plugins,$old_plugins=false)
{
	$handle=opendir($path);
	while ($file = readdir($handle)) {
		// Old fashionned plugins
		if ($old_plugins && substr($file,-5)=='.info' && is_file($path.$file)){
			$infile=new file($path.$file);
			$parameterlist=$infile->read();
			$parameter=explode(";",$parameterlist);
			for ($i=0;$i<count($parameter)-1;$i++){
				$pair=explode("=",trim($parameter[$i]));
				$value[$pair[0]]=$pair[1];
			}
			$value["dir"]=$value["directory"];
			$plugins[]=$value;
		} else
		// new format
		if (substr($file,-4)=='.php' && is_file($path.$file)){
			$infile=new file($path.$file);
			$filecontent=$infile->read();
			if (fetch_plugin_header($filecontent,$header))
			{
				// Fetch the metadata
				// Get the name
				if (!fetch_plugin_metadata($header,'name',$p["name"]))
				{
					// No valid name => plugin not valid
					continue;
				}
				// Get the description
				if (!fetch_plugin_metadata($header,'description',$p["description"]))
				{
					// No valid description => plugin not valid
					continue;
				}
				// Get the dependencies
				if (!fetch_plugin_metadata($header,'dependencies',$p["dependencies"]))
				{
					// No valid dependencies => plugin not valid
					continue;
				}
				
				$p["file"]=substr($file,0,strlen($file)-4);
				$p["dir"]=str_replace('../includes/plugins/','',$path);
				$p["link"]=str_replace('../includes/plugins/','',$path.$file);
				
				$plugins[]=$p;
			}
			
		}else if (is_dir($path.$file) && $file != '.' && $file !='..')
		{
			// Recursively in other dirs
			search_plugins($path.$file.'/',$plugins);
		}
	}
	closedir($handle);
}
?>