<?php
# ************** LICENCE ****************
/*
	Copyright (c) PORTANEO.

	This file is part of POSH (Portaneo Open Source Homepage) http://sourceforge.net/projects/posh/.

	POSH is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version

	POSH is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with Posh.  If not, see <http://www.gnu.org/licenses/>.
*/
# ***************************************
# POSH Module management - Apply module modifications
#
# !! be careful, this file must be saved under uft8 format, and display an e accentuated here : é
# ***************************************

$folder="";
$not_access=1;
$isScript=true;
$isPortal=false;
$granted="A";
$pagename="admin/scr_module_modify.php";
//includes
require_once("includes.php");
require_once('../includes/refreshcache.inc.php');
require_once('../includes/misc.inc.php');


launch_hook('admin_scr_module_modify');

// Get the ID of the treated module
$itemid=$_POST["itemid"];
$catid=$_POST["catid"];
$oldcatid=$_POST["oldcatid"];

// Save module changes
$minwidth=$_POST["minwidth"];
$sizable=1;
if ($minwidth==400) $sizable=0;
$url=$_POST["url"];
if (strpos($url,"?")===false)
{
	$url.="?";
}
else
{
	$url.="&";
}
$DB->execute($module_updateModule,$DB->quote($url),$DB->quote($_POST["name"]),$DB->quote($_POST["desc"]),$DB->quote($_POST["typ"]),$DB->quote($_POST["status"]),$DB->escape($_POST["size"]),$DB->escape($minwidth),$DB->escape($sizable),$DB->quote($_POST["website"]),$DB->escape($itemid));

if ($catid!=0)
{
	//check if the category mapping is already existing
	$DB->getResults($module_getModuleDirectory,$DB->escape($itemid));
	if ($DB->nbResults()==0)
	{
		$DB->execute($module_addModuleDirectory,$DB->escape($itemid),$DB->escape($catid));
	}
	else
	{
		//update the mapping
		$DB->execute($module_updateModuleDirectory,$DB->escape($catid),$DB->escape($itemid));
	}
}

// Suppress the module keywords
$DB->execute($module_removeKeywords,$DB->escape($itemid));

// add the module new keywords
for ($i=0;$i<40;$i++)
{
	if (!empty($_POST["kw".$i]))
	{
		$kw=$_POST["kw".$i];
		$kwsimplified=trim(suppress_accent($kw));
		$kwsimplified=strtolower($kwsimplified);
		$DB->getResults($module_getKeyword,$DB->quote($kwsimplified));
		if ($DB->nbResults()==0)
		{
			$DB->execute($module_addKeyword,$DB->quote($kw),$DB->quote($kwsimplified));
			$kwid=$DB->getId();
		}
		else
		{
			$row = $DB->fetch(0);
			$kwid=$row["id"];
		}
		$DB->freeResults();

		$DB->execute($module_addModuleKeyword,$kwid,$DB->escape($itemid),$DB->escape($_POST["w".$i]));
	}
}

refresh_item($itemid,$template_folder);
refresh_directory($catid,$template_folder,"");

// category changes
if ($catid!=$oldcatid)
{
	refresh_directory($oldcatid,$template_folder,"");
	$reload="&reload=1";
}
else
{
	$reload="";
}

header("location:frm_module_modify.php?itemid=".$itemid."&reload=1");
?>