<?php
# ************** LICENCE ****************
/*
	Copyright (c) PORTANEO.

	This file is part of POSH (Portaneo Open Source Homepage) http://sourceforge.net/projects/posh/.

	POSH is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version

	POSH is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with Posh.  If not, see <http://www.gnu.org/licenses/>.
*/
# ***************************************
# POSH Module management - Validate module
#
# !! be careful, this file must be saved under uft8 format, and display an e accentuated here : é
#
# inputs
#	itemid (POST) : module temp id
#	catid (POST) : module directory id
#	url (POST)
#	size (POST) : module height
#	minwidth(POST) : module minimal width
#	desc (POST) : module description
#	website(POST) : module linked website
#	name (POST) : module name
#	kwx(POST) : keywords label
#	wx(POST) : keywords weight
# ***************************************

$folder="";
$not_access=1;
$isScript=true;
$isPortal=false;
$granted="A";
$pagename="admin/scr_module_validate.php";
//includes
require_once("includes.php");
require_once('../includes/refreshcache.inc.php');
require_once('../l10n/'.__LANG.'/admin.lang.php');
require_once('../includes/misc.inc.php');


launch_hook('admin_scr_module_validate');

$id=$_POST["itemid"];
$catid=$_POST["catid"];

$DB->getResults($module_getTempModule,$DB->escape($id));
$row = $DB->fetch(0);
$url=$_POST["url"];
//url preparation to be shown in personal portals with variables
if (strpos($url, "?")===false)
{
	$url.="?";
}
else
{
	$url.="&";
}
$size=$_POST["size"];
$minwidth=$_POST["minwidth"];
$sizable=$row["sizable"];
$logo=$row["logo"];
$desc=$_POST["desc"];
$website=$_POST["website"];
//format for Google search
$website=str_replace("http://www.","",$website);
$website=str_replace("http://fr.","",$website);
$website=str_replace("http://","",$website);
$keys=$row["keyword"];
$format=$row["format"];
$typ=$row["typ"];
$var=$row["defvar"];
$editor=$row["edemail"];
$lang=$row["lang"];
$name=$_POST["name"];
$DB->freeResults();	

$defvar=($format=="R")?"nb=5":"";
$DB->execute($module_validateModule,$DB->quote($url),$DB->quote($name),$DB->quote($desc),$DB->escape($size),$DB->escape($minwidth),$DB->quote($website),$DB->escape($id));
$newid = $DB->getId();

// remove widget from temp table
if ($DB->nbAffected()>0)
{
	$DB->execute($module_removeTempModule,$DB->escape($id));
}

if ($format!="R")
{
	//move widget from quarantine to final folder
	copy("../modules/tmp_module".$id."_param.xml","../modules/module".$newid."_param.xml");

	if ($format!="U")
	{
		$newUrl="../modules/module".$newid.".php";
		copy("../modules/tmp_module".$id.".php",$newUrl);

		$DB->execute($module_setNewUrl,$DB->quote($newUrl."?"),$newid);
	}
}

// define directory for the widget
$DB->execute($module_addDirectoryTempModule,$newid,$DB->escape($id));

if ($catid>0)
{
	$DB->execute($module_addModuleSubDirectory,$newid,$DB->escape($catid),$DB->escape($id));
	if ($DB->nbAffected()>0)
	{
		$DB->execute($module_removeTempDirectory,$DB->escape($id));
	}
}

//if module linked with rss feed, set the link
if ($typ=="R"){
	$fid=0;
	$parameter=explode("&",$var);
	for ($i=0;$i<count($parameter)-1;$i++)
	{
		$pair=explode("=",trim($parameter[$i]));
		if ($pair[0]=="fid") $fid=$pair[1];
	}
	if ($fid!=0)
	{
		$DB->execute($module_addRedactorFeed,$newid,$fid);
	}
}

//add the new keywords
for ($i=0;$i<40;$i++){
	if (!empty($_POST["kw".$i]))
	{
		$kw=$_POST["kw".$i];
		$kwsimplified=trim(suppress_accent($kw));
		$kwsimplified=strtolower($kwsimplified);

		$DB->getResults($module_getValidationKeyword,$DB->quote($kwsimplified));
		if ($DB->nbResults()==0)
		{
			$DB->execute($module_addValidationKeyword,$DB->quote($kw),$DB->quote($kwsimplified));
			$kwid=$DB->getId();
		}
		else
		{
			$row = $DB->fetch(0);
			$kwid=$row["id"];
		}
		$DB->freeResults();

		$DB->execute($module_addValidationModuleKeyword,$kwid,$newid,$DB->escape($_POST["w".$i]));

	}
}

refresh_item($newid,$template_folder);
refresh_directory($catid,$template_folder,$lang);

//copy the files
@copy("../modules/quarantine/icon".$id.".ico", "../modules/pictures/box0_".$newid.".ico");


launch_hook('admin_scr_module_validate_end');


header("location:frm_module_modify.php?itemid=".$newid."&reload=1");
?>