<?php
# ************** LICENCE ****************
/*
	Copyright (c) PORTANEO.

	This file is part of POSH (Portaneo Open Source Homepage) http://sourceforge.net/projects/posh/.

	POSH is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version

	POSH is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with Posh.  If not, see <http://www.gnu.org/licenses/>.
*/
# ***************************************
# POSH Module management - Validate all modules
#
# !! be careful, this file must be saved under uft8 format, and display an e accentuated here : é
# ***************************************

$folder="";
$not_access=1;
$isScript=true;
$isPortal=false;
$granted="A";
$pagename="admin/scr_module_validateall.php";
//includes
require_once("includes.php");
require_once('../includes/refreshcache.inc.php');
require_once('../l10n/'.__LANG.'/admin.lang.php');
require_once('../includes/misc.inc.php');


launch_hook('admin_scr_module_validateall');

//loop on each module to validate
$DB->sql = $scr_modulevalidateall_getItems;
$rows = $DB->select(FETCH_ARRAY);
foreach ($rows as $row)
{
	$id=$row["id"];
	$url=$row["url"];
	$name=$row["name"];
	$desc=$row["description"];
	$size=$row["height"];
	$minwidth=$row["minwidth"];
	$website=$row["website"];
	$catid=$row["category_id"];
	$typ=$row["typ"];
	$format=$row["format"];
	$var=$row["defvar"];
	$lang=$row["lang"];
	$keywords=$row["keywords"];

	// validate module information
	$DB->execute($module_validateModule,$DB->quote($url),$DB->quote($name),$DB->quote($desc),$DB->escape($size),$DB->escape($minwidth),$DB->quote($website),$id);
	$newid = $DB->getId();
	if ($DB->nbAffected()>0)
	{
		$DB->execute($module_removeTempModule,$id);
	}
	
	if ($format!="R")
	{
		//move widget from quarantine to final folder
		copy("../modules/tmp_module".$id."_param.xml","../modules/module".$newid."_param.xml");

		if ($format!="U")
		{
			$newUrl="../modules/module".$newid.".php";
			copy("../modules/tmp_module".$id.".php",$newUrl);

			$DB->execute($module_setNewUrl,$DB->quote($newUrl."?"),$newid);
		}
	}

	// add directory information
	$DB->execute($module_addDirectoryTempModule,$newid,$id);

	if ($catid>0)
	{
		$DB->execute($module_addModuleSubDirectory,$newid,$catid,$id);
		if ($DB->nbAffected()>0)
		{
			$DB->execute($module_removeTempDirectory,$id);
		}
	}

	//if module linked with rss feed, set the link
	if ($typ=="R")
	{
		$fid=0;
		$parameter=explode("&",$var);
		for ($i=0;$i<count($parameter)-1;$i++)
		{
			$pair=explode("=",trim($parameter[$i]));
			if ($pair[0]=="fid") $fid=$pair[1];
		}
		if ($fid!=0)
		{
			$DB->execute($module_addRedactorFeed,$newid,$fid);
		}
	}

	//add the new keywords
	$keysarr=explode(",",$keywords);
	for ($i=0;$i<count($keysarr);$i++)
	{
		$kw=$keysarr[$i];
		$kwsimplified=trim(suppress_accent($kw));
		$kwsimplified=strtolower($kwsimplified);
		if (!Empty($kw))
		{
			$DB->getResults($module_getValidationKeyword,$DB->quote($kwsimplified));
			if ($DB->nbResults()==0)
			{
				$DB->execute($module_addValidationKeyword,$DB->quote($kw),$DB->quote($kwsimplified));
				$kwid=$DB->getId();
			}
			else
			{
				$row = $DB->fetch(0);
				$kwid=$row["id"];
			}
			$DB->freeResults();

			$DB->execute($module_addValidationModuleKeyword,$kwid,$newid,2);
		}
	}

	refresh_item($newid,$template_folder);
	refresh_directory($catid,$template_folder,$lang);

	//copy the files
	@copy("../modules/quarantine/icon".$id.".ico", "../modules/pictures/box0_".$newid.".ico");
}


launch_hook('admin_scr_module_validateall_end');

header("location:modules_mgmt.php");
?>