<?php
/*
	Copyright (c) PORTANEO.

	This file is part of POSH (Portaneo Open Source Homepage) http://sourceforge.net/projects/posh/.

	POSH is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version

	POSH is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with Posh.  If not, see <http://www.gnu.org/licenses/>.
*/
# !! be careful, this file must be saved under uft8 format, and display an e accentuated here : é
// Functions used in widget creation interfaces
function secureWidgetCode($code)
{
	if (strpos($code,"<"."?")!==false) $code="PHP is not allowed in the widgets code.";
	if (strpos($code,"<"."%")!==false) $code="server scripting is not allowed in the widgets code.";
	//search in script tag if no forbidden actions are launched
	$parts=preg_split("/<\/?script(>| )/",$code);
	for($i=1;$i<count($parts)-1;$i+=2)
	{
		$scriptContent=strtolower($parts[$i]);
		if (strpos($scriptContent,"parent.")!==false) $code="parent object not allowed in widget code (Portaneo security restriction).";
		if (strpos($scriptContent,"window.parent")!==false) $code="parent object not allowed in widget code (Portaneo security restriction).";
		if (strpos($scriptContent,"document.parent")!==false) $code="parent object not allowed in widget code (Portaneo security restriction).";
		if (strpos($scriptContent,"=parent")!==false) $code="parent object not allowed in widget code (Portaneo security restriction).";
		if (strpos($scriptContent,":parent")!==false) $code="parent object not allowed in widget code (Portaneo security restriction).";
		if (strpos($scriptContent,"top.")!==false) $code="top object not allowed in widget code (Portaneo security restriction).";
		if (strpos($scriptContent,"window.top")!==false) $code="top object not allowed in widget code (Portaneo security restriction).";
		if (strpos($scriptContent,"document.top")!==false) $code="top object not allowed in widget code (Portaneo security restriction).";
		if (strpos($scriptContent,"=top")!==false) $code="top object not allowed in widget code (Portaneo security restriction).";
		if (strpos($scriptContent,":top")!==false) $code="top object not allowed in widget code (Portaneo security restriction).";
		if (strpos($scriptContent,"eval(")!==false) $code="eval function is not allowed in the widgets code (Portaneo security restriction).";
		if (strpos($scriptContent,"=eval")!==false) $code="eval function is not allowed in the widgets code (Portaneo security restriction).";
		if (strpos($scriptContent,":eval")!==false) $code="eval function is not allowed in the widgets code (Portaneo security restriction).";
		//if (strpos($scriptContent," src=")!==false) $code="No javascript include in widgets (Portaneo security restriction)."; // to improve
	}

	return $code;
}
function formatWidgetCode($code)
{
	$code = stripslashes($code);
	$code = eregi_replace("<script","<script",$code);
	$code = eregi_replace("</script","</script",$code);

	return $code;
}
?>