<?php
/*
	Copyright (c) PORTANEO.

	This file is part of POSH (Portaneo Open Source Homepage) http://sourceforge.net/projects/posh/.

	POSH is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version

	POSH is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with Posh.  If not, see <http://www.gnu.org/licenses/>.
*/
/* UTF8 encoding : é ù à ô */
set_time_limit(300);
if (!isset($_POST["server"])) exit();
if (!isset($_POST["login"])) exit();
if (!isset($_POST["pass"])) exit();
if (!isset($_POST["db"])) exit();
if (!isset($_POST["dbtype"])) exit();
$dbtype=$_POST["dbtype"];

$not_access=0;
require_once('../includes/config.inc.php');
require_once('../includes/session.inc.php');
require_once('../includes/connection_'.$dbtype.'.inc.php');
require_once('../db_layer/'.$dbtype.'/install.php');
require_once('../includes/file.inc.php');
require_once('functions.inc.php');
require_once('confinstall.inc.php');

$server=trim($_POST["server"]);
$login=trim($_POST["login"]);
$pass=trim($_POST["pass"]);
$db=trim($_POST["db"]);
$errors=false;

//server connection
global $DB;
$DB = new connection($server,$login,$pass,$db);
if (!$DB->id)
{
	header("location:step2.php?err=1");
	exit();
}

//database creation
$selectdb=$DB->selectDB($db);

if (!$selectdb){
	$createdb=$DB->execute($install_createDB,$db);
	if (!$createdb)
	{
		header("location:step2.php?err=2");
		exit();
	}
	$DB->selectDB($db);
}

//check if objects are already existing
if (__INSTALLTYPE==2){
	$DB->getResults($install_listExistingTables);
	
	if ($DB->nbResults()>0 AND !isset($_POST["reprev"]))
	{
		header("location:step2.php?err=3");
		exit();
	}
	$DB->freeResults();
}

$currversion="0.0.0";
$installingversion="0.0.0";
//correct bug on v1.0.1
$DB->execute($install_bugcorrection101);
// if posh upgrade, get the old version
if (__INSTALLTYPE==1){
	$DB->getResults($install_getPreviousVersion);

	if ($DB->nbResults()>0){
		$row=$DB->fetch(0);
		$currversion=$row["value"];
	} else {
		$currversion="1.0.0";
	}

	$DB->freeResults();
}

//objects creation
//treat each createdb....sql file
$handle=opendir("../install/");

//get the sql commands for installed versions
$SQL=Array();

while ($file = readdir($handle)) {
	if (substr($file,0,8)=='createdb' && substr($file,-4)=='.sql' && !(strpos($file,$dbtype)===false)){
		$sqlfile=new file($file);
		$sqlcontent=$sqlfile->read();

		$sqlcontent = preg_replace('/\r\n|\r/', "\n", $sqlcontent); //win, mac newlines to nix.

		$sql=explode(";\n",$sqlcontent);
//		$sql=explode(";\r\n",$sqlcontent);

		$treat=true;
		for ($i=0;$i<count($sql);$i++){
			$strsql=trim($sql[$i]);

			if (!empty($strsql) && $strsql[0] == ">"){
				// check that db upgrade section needs to be apply
				$scriptversion = trim(substr($strsql,1));

				if (!array_key_exists($scriptversion,$SQL))
					$SQL[$scriptversion]=Array();
				if (__INSTALLTYPE==1){
					if (version_compare($currversion, $scriptversion, ">="))
					{
						$treat=false;
					}
					else
					{
						$treat=true;
					}
				}
				if (version_compare($scriptversion, $installingversion, ">"))
					$installingversion=$scriptversion;
			} else if (!Empty($strsql) AND $treat){
				array_push($SQL[$scriptversion],$strsql);
			}
		}
	}
}
closedir($handle);

//treat the sql commands
ksort($SQL);

while (list($key, $val) = each($SQL))
{
	while (list($key2,$val2) = each($SQL[$key]))
	{
		if (!$DB->execute($val2))
		{
			echo "<div style='border:1px solid #c6c3c6;background-color:#efefef;font-size:9pt;'><b>Error :</b> ".$DB->showError()."<br />On following SQL command : ".$val2."</div><br />";
			$errors=true;
		}
	}
}

//additional objects creation
//if (I_ADDITIONAL_SCRIPT!=""){
//	$sqlfile=new file(I_ADDITIONAL_SCRIPT);
//	$sqlcontent=$sqlfile->read();
//	$sql=explode(";",$sqlcontent);
//	$treat=true;
//	for ($i=0;$i<count($sql);$i++){
//		$strsql=trim($sql[$i]);
//		if ($strsql!="" AND $strsql{0}==">"){
//			if (__INSTALLTYPE==1){
//				// check that db upgrade section needs to be apply
//				if (version_compare($currversion, substr($strsql,1), ">=")) {$treat=false;} else {$treat=true;}
//			}
//		} else if (!Empty($strsql) AND $treat){
//			if (!mysql_query($strsql,$conn)){
//				echo "error on following SQL command: <b>".$strsql."</b> (".mysql_error().")<br />";
//				$errors=true;
//			}
//		}
//	}
//}

//save configuration to db
if (!$DB->execute($install_setServer,$DB->quote($server)))
{
	header("location:step2.php?err=4");
	exit();
}
if (!$DB->execute($install_setLogin,$DB->quote($login)))
{
	header("location:step2.php?err=4");
	exit();
}
if (!$DB->execute($install_setPass,$DB->quote($pass)))
{
	header("location:step2.php?err=4");
	exit();
}
if (!$DB->execute($install_setDB,$DB->quote($db)))
{
	header("location:step2.php?err=4");
	exit();
}

$DB->execute($install_updDBType,$DB->quote($dbtype));
if ($DB->nbAffected()<1)
{
	$DB->execute($install_insertDBType,$DB->quote($dbtype));
}

//add in adm_config the old version
if (!$DB->execute($install_setPoshVersion,$DB->quote($currversion)))
{
	header("location:step2.php?err=4");
	exit();
}

// add in adm_config the new version
if (version_compare(I_POSH_INSTALLING_VERSION, $installingversion, ">"))
	$installingversion=I_POSH_INSTALLING_VERSION;  //avoid errors when posh installing version is not correct in conf files
	
$DB->execute($install_updInstallingPoshVersion,$DB->quote($installingversion),"'INSTALLINGPOSHVE%'");
if ($DB->nbAffected()<1)
{
	$DB->execute($install_insertInstallingPoshVersion,$DB->quote($installingversion));
}

$DB->execute($install_updInstallType,$DB->quote(__INSTALLTYPE));
if ($DB->nbAffected()<1)
{
	$DB->execute($install_insertInstallType,$DB->quote(__INSTALLTYPE));
}

$DB->execute($install_setStep3);
if ($DB->nbAffected()<1)
{
	$DB->execute($install_insertStep3);
}
//for enterprise solution, update version
if (I_APPLICATION_ID==2)
{
	$DB->execute($install_updateEnterpriseVersion,$DB->quote(I_ENTERPRISE_INSTALLING_VERSION));
}

//generate config file
generateConfigFile(false,$server,$login,$pass,$db);

$DB->close();

if ($errors)
{
	echo "<br /><a href='step2.php'>Restart</a> OR <a href='step3.php'>Continue with next step (potential information missing)</a>";
}
else
{
	header("location:step3.php");
	exit();
}
?>